<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>src.dataframe &#8212; pandas 2.1.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=841abef3"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for src.dataframe</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">.common</span> <span class="kn">import</span> <span class="n">processor</span><span class="p">,</span> <span class="n">params_to_dict</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">click</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">ast</span> <span class="kn">import</span> <span class="n">literal_eval</span>
<span class="kn">from</span> <span class="nn">tabulate</span> <span class="kn">import</span> <span class="n">tabulate</span>


<div class="viewcode-block" id="index">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.index">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">index</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    The index (row labels) of the DataFrame.</span>

<span class="sd">    The index of a DataFrame is a series of labels that identify each row. The</span>
<span class="sd">    labels can be integers, strings, or any other hashable type. The index is</span>
<span class="sd">    used for label-based access and alignment, and can be accessed or modified</span>
<span class="sd">    using this attribute.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="p">))</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="columns">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.columns">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">columns</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    The column labels of the DataFrame.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">columns</span><span class="p">))</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="dtypes">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.dtypes">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">dtypes</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return the dtypes in the DataFrame.</span>

<span class="sd">    This returns a Series with the data type of each column. The result&#39;s index</span>
<span class="sd">    is the original DataFrame’s columns. Columns with mixed types are stored</span>
<span class="sd">    with the object dtype. See the User Guide for more.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">dtypes</span><span class="p">))</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="info">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.info">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">info</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Print a concise summary of a DataFrame.</span>

<span class="sd">    This method prints information about a DataFrame including the index dtype</span>
<span class="sd">    and columns, non-null values and memory usage.</span>

<span class="sd">    ## Parameters</span>
<span class="sd">    </span>
<span class="sd">    \b</span>
<span class="sd">        verbose=None</span>
<span class="sd">        buf=None</span>
<span class="sd">        max_cols=None</span>
<span class="sd">        memory_usage=None</span>
<span class="sd">        show_counts=None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<span class="c1"># TODO: values</span>


<div class="viewcode-block" id="axes">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.axes">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">axes</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return a list representing the axes of the DataFrame.</span>

<span class="sd">    It has the row axis labels and column axis labels as the only members. They</span>
<span class="sd">    are returned in that order.</span>

<span class="sd">    ## Parameters</span>
<span class="sd">    </span>
<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">([</span><span class="nb">list</span><span class="p">(</span><span class="n">ax</span><span class="p">)</span> <span class="k">for</span> <span class="n">ax</span> <span class="ow">in</span> <span class="n">df</span><span class="o">.</span><span class="n">axes</span><span class="p">])</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="size">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.size">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">size</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return an int representing the number of elements in this object.</span>

<span class="sd">    Return the number of rows if Series. Otherwise return the number of rows</span>
<span class="sd">    times number of columns if DataFrame.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">size</span><span class="p">)</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="shape">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.shape">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">shape</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return a tuple representing the dimensionality of the DataFrame.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="memory_usage">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.memory_usage">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">memory_usage</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return the memory usage of each column in bytes.</span>

<span class="sd">    The memory usage can optionally include the contribution of the index and</span>
<span class="sd">    elements of object dtype.</span>

<span class="sd">    This value is displayed in DataFrame.info by default. This can be</span>
<span class="sd">    suppressed by setting pandas.options.display.memory_usage to False.</span>

<span class="sd">    # Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        index=True</span>
<span class="sd">        deep=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">memory_usage</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">))</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="empty">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.empty">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">empty</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Indicator whether Series/DataFrame is empty.</span>

<span class="sd">    True if Series/DataFrame is entirely empty (no items), meaning any of the</span>
<span class="sd">    axes are of length 0.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">empty</span><span class="p">)</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="tabular">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.tabular">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-f&quot;</span><span class="p">,</span> <span class="s2">&quot;--format&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Choice</span><span class="p">([</span>
            <span class="s2">&quot;plain&quot;</span><span class="p">,</span>
            <span class="s2">&quot;simple&quot;</span><span class="p">,</span>
            <span class="s2">&quot;github&quot;</span><span class="p">,</span>
            <span class="s2">&quot;grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;simple_grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;rounded_grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;heavy_grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;mixed_grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;double_grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;fancy_grid&quot;</span><span class="p">,</span>
            <span class="s2">&quot;outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;simple_outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;rounded_outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;heavy_outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;mixed_outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;double_outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;fancy_outline&quot;</span><span class="p">,</span>
            <span class="s2">&quot;pipe&quot;</span><span class="p">,</span>
            <span class="s2">&quot;orgtbl&quot;</span><span class="p">,</span>
            <span class="s2">&quot;asciidoc&quot;</span><span class="p">,</span>
            <span class="s2">&quot;jira&quot;</span><span class="p">,</span>
            <span class="s2">&quot;presto&quot;</span><span class="p">,</span>
            <span class="s2">&quot;pretty&quot;</span><span class="p">,</span>
            <span class="s2">&quot;psql&quot;</span><span class="p">,</span>
            <span class="s2">&quot;rst&quot;</span><span class="p">,</span>
            <span class="s2">&quot;mediawiki&quot;</span><span class="p">,</span>
            <span class="s2">&quot;moinmoin&quot;</span><span class="p">,</span>
            <span class="s2">&quot;youtrack&quot;</span><span class="p">,</span>
            <span class="s2">&quot;html&quot;</span><span class="p">,</span>
            <span class="s2">&quot;unsafehtml&quot;</span><span class="p">,</span>
            <span class="s2">&quot;latex&quot;</span><span class="p">,</span>
            <span class="s2">&quot;latex_raw&quot;</span><span class="p">,</span>
            <span class="s2">&quot;latex_booktabs&quot;</span><span class="p">,</span>
            <span class="s2">&quot;latex_longtable&quot;</span><span class="p">,</span>
            <span class="s2">&quot;textile&quot;</span><span class="p">,</span>
            <span class="s2">&quot;tsv&quot;</span><span class="p">],</span> <span class="n">case_sensitive</span><span class="o">=</span><span class="kc">False</span><span class="p">),</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Print the DataFrame as a formatted table.&quot;</span>
<span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">tabular</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="nb">format</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Print a DataFrame to the stdout.</span>

<span class="sd">    ## Paramters</span>

<span class="sd">    \b</span>
<span class="sd">        headers=[list of column headers|&quot;firstrow&quot;|&quot;keys&quot;]</span>
<span class="sd">        floatfmt=&#39;g&#39;</span>
<span class="sd">        intfmt=&#39;&#39;</span>
<span class="sd">        numalign=&#39;default&#39;</span>
<span class="sd">        stralign=&#39;default&#39;</span>
<span class="sd">        missingval=&#39;&#39;</span>
<span class="sd">        showindex=&#39;default&#39;</span>
<span class="sd">        disable_numparse=False</span>
<span class="sd">        colalign=None</span>
<span class="sd">        maxcolwidths=None</span>
<span class="sd">        rowalign=None</span>
<span class="sd">        maxheadercolwidths=None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">pd_params</span><span class="p">[</span><span class="s2">&quot;headers&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">pd_params</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;header&quot;</span><span class="p">,</span> <span class="s2">&quot;keys&quot;</span><span class="p">)</span>
        <span class="n">click</span><span class="o">.</span><span class="n">echo</span><span class="p">(</span><span class="n">tabulate</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">tablefmt</span><span class="o">=</span><span class="nb">format</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">))</span>
        <span class="k">yield</span></div>



<div class="viewcode-block" id="astype">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.astype">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--type&quot;</span><span class="p">,</span> <span class="s2">&quot;-t&quot;</span><span class="p">,</span> <span class="s2">&quot;type_&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;&quot;&quot;</span>
<span class="s2">            Use a str, numpy.dtype, pandas.ExtensionDtype or Python type to</span>
<span class="s2">            cast entire pandas object to the same type. Alternatively, use a</span>
<span class="s2">            mapping, e.g. {&#39;col&#39;\: &#39;&lt;type&gt;&#39;, ...}, where col is a column label</span>
<span class="s2">            and dtype is a numpy.dtype or Python type to cast one or more of</span>
<span class="s2">            the DataFrame’s columns to column-specific types.</span>
<span class="s2">            </span>
<span class="s2">            *IMPORTANT* If using a map, ensure all keys and values are strings.</span>
<span class="s2">            &quot;&quot;&quot;</span>
<span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">astype</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">type_</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Cast a pandas object to a specified data type.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">astype</span><span class="p">(</span><span class="n">type_</span><span class="p">)</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">astype</span><span class="p">(</span><span class="n">literal_eval</span><span class="p">(</span><span class="n">type_</span><span class="p">))</span></div>



<div class="viewcode-block" id="convert_dtypes">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.convert_dtypes">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">convert_dtypes</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Convert columns to the best possible dtypes using dtypes supporting pd.NA.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        infer_objects=True</span>
<span class="sd">        convert_string=True</span>
<span class="sd">        convert_integer=True</span>
<span class="sd">        convert_boolean=True</span>
<span class="sd">        convert_floating=True</span>
<span class="sd">        dtype_backend=&#39;numpy_nullable&#39;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">convert_dtypes</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="infer_objects">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.infer_objects">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">infer_objects</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Attempt to infer better dtypes for object columns.</span>

<span class="sd">    Attempts soft conversion of object-dtyped columns, leaving non-object and</span>
<span class="sd">    unconvertible columns unchanged. The inference rules are the same as during</span>
<span class="sd">    normal Series/DataFrame construction.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">infer_objects</span><span class="p">(</span><span class="n">copy</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span></div>



<div class="viewcode-block" id="head">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.head">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-n&quot;</span><span class="p">,</span> <span class="s2">&quot;--num&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Number of rows to print. Default: 5.&quot;</span>
<span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">head</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">num</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return the first n rows.</span>

<span class="sd">    This function returns the first n rows for the object based on position.</span>
<span class="sd">    It is useful for quickly testing if your object has the right type of data</span>
<span class="sd">    in it.</span>

<span class="sd">    For negative values of n, this function returns all rows except the last</span>
<span class="sd">    |n| rows, equivalent to df[:n].</span>

<span class="sd">    If n is larger than the number of rows, this function returns all rows.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">head</span><span class="p">(</span><span class="n">num</span><span class="p">)</span></div>



<div class="viewcode-block" id="idxmax">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.idxmax">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">idxmax</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return index of first occurrence of maximum over requested axis.</span>

<span class="sd">    NA/null values are excluded.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        skipna=True</span>
<span class="sd">        numeric_only=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">idxmax</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span></div>



<div class="viewcode-block" id="idxmin">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.idxmin">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">idxmin</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return index of first occurrence of minimum over requested axis.</span>

<span class="sd">    NA/null values are excluded.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        skipna=True</span>
<span class="sd">        numeric_only=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">idxmin</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span></div>



<div class="viewcode-block" id="tail">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.tail">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-n&quot;</span><span class="p">,</span> <span class="s2">&quot;--num&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Number of rows to print. Default: 5.&quot;</span>
<span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">tail</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">num</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return the last n rows equivalent to df[|n|:].</span>

<span class="sd">    This function returns the last n rows for the object based on position.</span>
<span class="sd">    It is useful for quickly testing if your object has the right type of data</span>
<span class="sd">    in it.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">tail</span><span class="p">(</span><span class="n">num</span><span class="p">)</span></div>



<div class="viewcode-block" id="xs">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.xs">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-k&quot;</span><span class="p">,</span> <span class="s2">&quot;--key&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">multiple</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The key or, if passed multiple times, keys to access from a multi-index dataframe.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">xs</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return cross-section from the Series/DataFrame.</span>

<span class="sd">    This method takes a key argument to select data at a particular level of a</span>
<span class="sd">    MultiIndex.</span>

<span class="sd">    ## Parameters</span>
<span class="sd">    </span>
<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        level=[int|list-like]</span>
<span class="sd">        drop_level=True</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">k</span> <span class="o">=</span> <span class="n">key</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">key</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">key</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Cross section with </span><span class="si">{</span><span class="n">key</span><span class="si">}</span><span class="s2"> using </span><span class="si">{</span><span class="n">pd_params</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">xs</span><span class="p">(</span><span class="n">k</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">):</span>
            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Cross section resulted in a DataFrame.&quot;</span><span class="p">)</span>
            <span class="k">yield</span> <span class="n">result</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Cross section resulted in a Series.&quot;</span><span class="p">)</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span></div>



<div class="viewcode-block" id="get">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.get">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-k&quot;</span><span class="p">,</span> <span class="s2">&quot;--key&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">multiple</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The key or, if passed multiple times, keys to access from a dataframe.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">get</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Get item from object for given key (ex: DataFrame column).</span>

<span class="sd">    Keys provided through the &quot;--key&quot; option are always treated as strings.</span>
<span class="sd">    Keys provided through the &quot;--params&quot; option are duck-typed. The final set</span>
<span class="sd">    of keys is the combination of keys provided through these two options as</span>
<span class="sd">    if all &#39;--keys&#39; options were provided first, then all &quot;--params&quot; options,</span>
<span class="sd">    regardless of the order in which these appear on the command line.</span>

<span class="sd">    *Note*: The relative order of labels provided by the &quot;--keys&quot; and</span>
<span class="sd">    &quot;--params&quot; options are respected.</span>

<span class="sd">    Example:</span>

<span class="sd">    \b</span>
<span class="sd">        pd ... get -k k1 -k k2 -p &quot;key=[&#39;p1&#39;, &#39;p2&#39;]&quot; -k k3</span>
<span class="sd">    </span>
<span class="sd">    will produce a table,</span>

<span class="sd">    \b</span>
<span class="sd">        +----+----+----+----+----+----+</span>
<span class="sd">        |    | k1 | k2 | k3 | p1 | p2 |</span>
<span class="sd">        +----+----+----+----+----+----+</span>
<span class="sd">        | 0  | &lt;table values here&gt;    |</span>
<span class="sd">        +----+----+----+----+----+----+</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        key</span>
<span class="sd">        default=None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">keys</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">key</span><span class="p">)</span> <span class="o">+</span> <span class="n">pd_params</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;key&quot;</span><span class="p">,</span> <span class="p">[])</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">keys</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="query">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.query">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-e&quot;</span><span class="p">,</span> <span class="s2">&quot;--expression&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The query expression to be evaluated.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">query</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">expression</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Query the columns of a DataFrame with a boolean expression.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">query</span><span class="p">(</span><span class="n">expression</span><span class="p">,</span> <span class="n">inplace</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span></div>



<div class="viewcode-block" id="agg">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.agg">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-f&quot;</span><span class="p">,</span> <span class="s2">&quot;--func&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The reduction/aggregation function to apply.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-a&quot;</span><span class="p">,</span> <span class="s2">&quot;--axis&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Axis along which to apply the aggregation function.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">agg</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">func</span><span class="p">,</span> <span class="n">axis</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Aggregate using one or more operations over the specified axis.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">agg</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">axis</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">):</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="groupby">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.groupby">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-f&quot;</span><span class="p">,</span> <span class="s2">&quot;--func&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Reduction function to apply after grouping.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">groupby</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">func</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Group DataFrame using a mapper or by a Series of columns.</span>

<span class="sd">    A groupby operation involves some combination of splitting the object,</span>
<span class="sd">    applying a function, and combining the results. This can be used to group</span>
<span class="sd">    large amounts of data and compute operations on these groups.</span>

<span class="sd">    The &#39;-f/--func&#39; option sets the reduction to apply to group.</span>
<span class="sd">    </span>
<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        by=None</span>
<span class="sd">        axis=_NoDefault.no_default</span>
<span class="sd">        level=None</span>
<span class="sd">        as_index=True</span>
<span class="sd">        sort=True</span>
<span class="sd">        group_keys=True</span>
<span class="sd">        observed=_NoDefault.no_default</span>
<span class="sd">        dropna=True)[source]</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">group</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">groupby</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">group</span><span class="p">,</span> <span class="n">func</span><span class="p">)()</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">):</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">result</span></div>



<span class="c1"># TODO: rolling</span>
<span class="c1"># TODO: expanding</span>


<div class="viewcode-block" id="corr">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.corr">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">corr</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Compute pairwise correlation of columns, excluding NA/null values.</span>
<span class="sd">    </span>
<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        method=[&#39;pearson&#39;|&#39;kendall&#39;|&#39;spearman&#39;]</span>
<span class="sd">        min_periods=1</span>
<span class="sd">        numeric_only=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">corr</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="describe">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.describe">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">describe</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Generate descriptive statistics.</span>

<span class="sd">    Descriptive statistics include those that summarize the central tendency,</span>
<span class="sd">    dispersion and shape of a dataset’s distribution, excluding NaN values.</span>

<span class="sd">    Analyzes both numeric and object series, as well as DataFrame column sets</span>
<span class="sd">    of mixed data types. The output will vary depending on what is provided.</span>
<span class="sd">    Refer to the notes below for more detail.</span>
<span class="sd">    </span>
<span class="sd">    ## Parameters</span>

<span class="sd">        percentiles=None</span>

<span class="sd">            The percentiles to include in the output. All should fall between 0</span>
<span class="sd">            and 1. The default is [.25, .5, .75], which returns the 25th, 50th,</span>
<span class="sd">            and 75th percentiles.</span>
<span class="sd">        </span>
<span class="sd">        include=None</span>
<span class="sd">        </span>
<span class="sd">        exclude=None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">describe</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">):</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="eval">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.eval">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-e&quot;</span><span class="p">,</span> <span class="s2">&quot;--expression&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Expression to evaluate on the DataFrame.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">eval</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">expression</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Evaluate a string describing operations on DataFrame columns.</span>

<span class="sd">    Operates on columns only, not specific rows or elements. This allows eval</span>
<span class="sd">    to run arbitrary code, which can make you vulnerable to code injection if</span>
<span class="sd">    you pass user input to this function.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">eval</span><span class="p">(</span><span class="n">expression</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">):</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="reduce">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.reduce">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-f&quot;</span><span class="p">,</span> <span class="s2">&quot;--func&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Choice</span><span class="p">([</span>
            <span class="s2">&quot;clip&quot;</span><span class="p">,</span>
            <span class="s2">&quot;count&quot;</span><span class="p">,</span>
            <span class="s2">&quot;cov&quot;</span><span class="p">,</span>
            <span class="s2">&quot;cummax&quot;</span><span class="p">,</span>
            <span class="s2">&quot;cummin&quot;</span><span class="p">,</span>
            <span class="s2">&quot;cumprod&quot;</span><span class="p">,</span>
            <span class="s2">&quot;cumsum&quot;</span><span class="p">,</span>
            <span class="s2">&quot;diff&quot;</span><span class="p">,</span>
            <span class="s2">&quot;kurtosis&quot;</span><span class="p">,</span>
            <span class="s2">&quot;max&quot;</span><span class="p">,</span>
            <span class="s2">&quot;mean&quot;</span><span class="p">,</span>
            <span class="s2">&quot;median&quot;</span><span class="p">,</span>
            <span class="s2">&quot;mode&quot;</span><span class="p">,</span>
            <span class="s2">&quot;pct_change&quot;</span><span class="p">,</span>
            <span class="s2">&quot;prod&quot;</span><span class="p">,</span>
            <span class="s2">&quot;quantile&quot;</span><span class="p">,</span>
            <span class="s2">&quot;rank&quot;</span><span class="p">,</span>
            <span class="s2">&quot;round&quot;</span><span class="p">,</span>
            <span class="s2">&quot;sem&quot;</span><span class="p">,</span>
            <span class="s2">&quot;skew&quot;</span><span class="p">,</span>
            <span class="s2">&quot;sum&quot;</span><span class="p">,</span>
            <span class="s2">&quot;std&quot;</span><span class="p">,</span>
            <span class="s2">&quot;var&quot;</span><span class="p">,</span>
            <span class="s2">&quot;nunique&quot;</span>
        <span class="p">],</span> <span class="n">case_sensitive</span><span class="o">=</span><span class="kc">False</span><span class="p">),</span>
        <span class="n">multiple</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Apply a reduction function on a DataFrame.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--flat&quot;</span><span class="p">,</span>
    <span class="n">is_flag</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;If set, each function produces a new column with a &#39;_&lt;func&gt;&#39; suffix.&quot;</span>
<span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">],</span>
        <span class="n">multiple</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">reduce</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">func</span><span class="p">,</span> <span class="n">flat</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Apply a reduction function to a DataFrame.</span>

<span class="sd">    If parameters are specified for one function, then they must either be</span>
<span class="sd">    specified for all functions or the first set of parameters specified will</span>
<span class="sd">    be used for each and all other parameters (or lack thereof) will be</span>
<span class="sd">    ignored.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    These functions are documented in the pandas documentation,</span>
<span class="sd">    https://pandas.pydata.org/docs/reference/frame.html.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">func</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">params</span><span class="p">):</span>
        <span class="n">alignedParams</span> <span class="o">=</span> <span class="n">params</span>
    <span class="k">else</span><span class="p">:</span> <span class="c1"># First set of parameters common to all functions.</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">alignedParams</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">func</span><span class="p">)</span><span class="o">*</span><span class="p">[</span><span class="n">params</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>
        <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
            <span class="n">alignedParams</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">func</span><span class="p">)</span><span class="o">*</span><span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">]</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">for</span> <span class="n">fn</span><span class="p">,</span> <span class="n">param</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">alignedParams</span><span class="p">):</span>
            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Applying </span><span class="si">{</span><span class="n">fn</span><span class="si">!r}</span><span class="s2"> in reduction using </span><span class="si">{</span><span class="n">param</span><span class="si">!r}</span><span class="s2">.&quot;</span><span class="p">)</span>
            <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">param</span><span class="p">)</span> <span class="k">if</span> <span class="n">param</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
            <span class="n">f</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">fn</span><span class="p">)</span>
            <span class="n">out</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span><span class="o">.</span><span class="n">rename</span><span class="p">(</span><span class="n">fn</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">result</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">out</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">merge</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">out</span><span class="p">,</span> <span class="n">how</span><span class="o">=</span><span class="s2">&quot;outer&quot;</span><span class="p">,</span> <span class="n">left_index</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">right_index</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">flat</span><span class="p">:</span>
            <span class="n">melted</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">reset_index</span><span class="p">()</span><span class="o">.</span><span class="n">melt</span><span class="p">(</span><span class="s2">&quot;index&quot;</span><span class="p">,</span> <span class="n">ignore_index</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">melted</span><span class="o">.</span><span class="n">index</span> <span class="o">=</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">a</span><span class="si">}</span><span class="s2">_</span><span class="si">{</span><span class="n">b</span><span class="si">}</span><span class="s2">&quot;</span> <span class="k">for</span> <span class="n">a</span><span class="p">,</span><span class="n">b</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">melted</span><span class="p">[</span><span class="s2">&quot;index&quot;</span><span class="p">],</span> <span class="n">melted</span><span class="p">[</span><span class="s2">&quot;variable&quot;</span><span class="p">])]</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">melted</span><span class="o">.</span><span class="n">drop</span><span class="p">([</span><span class="s2">&quot;index&quot;</span><span class="p">,</span> <span class="s2">&quot;variable&quot;</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">transpose</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="drop">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.drop">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">drop</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Drop specified labels from rows or columns.</span>

<span class="sd">    Remove rows or columns by specifying label names and corresponding axis, or</span>
<span class="sd">    by directly specifying index or column names. When using a multi-index,</span>
<span class="sd">    labels on different levels can be removed by specifying the level. See the</span>
<span class="sd">    user guide for more information about the now unused levels.</span>
<span class="sd">    </span>
<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        index</span>
<span class="sd">        columns</span>
<span class="sd">        level=None</span>
<span class="sd">        errors=[&#39;raise&#39;|&#39;ignore&#39;]</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">pd_params</span><span class="p">[</span><span class="s2">&quot;inplace&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">drop</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">):</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="stack">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.stack">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">stack</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Stack the prescribed level(s) from columns to index.</span>

<span class="sd">    Return a reshaped DataFrame or Series having a multi-level index with one</span>
<span class="sd">    or more new inner-most levels compared to the current DataFrame. The new</span>
<span class="sd">    inner-most levels are created by pivoting the columns of the current</span>
<span class="sd">    dataframe:</span>

<span class="sd">    - if the columns have a single level, the output is a Series;</span>

<span class="sd">    - if the columns have multiple levels, the new index level(s) is (are)</span>
<span class="sd">      taken from the prescribed level(s) and the output is a DataFrame.</span>
<span class="sd">    </span>
<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        level=-1</span>
<span class="sd">        dropna=_NoDefault.no_default</span>
<span class="sd">        sort=_NoDefault.no_default</span>
<span class="sd">        future_stack=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">stack</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">):</span>
            <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="unstack">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.unstack">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">unstack</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Pivot a level of the (necessarily hierarchical) index labels.</span>

<span class="sd">    Returns a DataFrame having a new level of column labels whose inner-most</span>
<span class="sd">    level consists of the pivoted index labels.</span>

<span class="sd">    If the index is not a MultiIndex, the output will be a Series (the analogue</span>
<span class="sd">    of stack when the columns are not a MultiIndex).</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        level=-1</span>
<span class="sd">        fill_value=None</span>
<span class="sd">        sort=True</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">unstack</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">)</span> <span class="k">else</span> <span class="n">result</span></div>



<div class="viewcode-block" id="transpose">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.transpose">[docs]</a>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">transpose</span><span class="p">(</span><span class="n">dfs</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Returns the transpose of the DataFrame.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">transpose</span><span class="p">()</span></div>



<div class="viewcode-block" id="sort_index">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.sort_index">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">sort_index</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Sort a DataFrame by index.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        level=None</span>
<span class="sd">        ascending=True</span>
<span class="sd">        kind=&#39;quicksort&#39;</span>
<span class="sd">        na_position=&#39;last&#39;</span>
<span class="sd">        sort_remaining=True</span>
<span class="sd">        ignore_index=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">sort_index</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">)</span> <span class="k">else</span> <span class="n">result</span></div>



<div class="viewcode-block" id="sort">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.sort">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">sort</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Sort by values along either axis.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        ascending=True</span>
<span class="sd">        kind=&#39;quicksort&#39;</span>
<span class="sd">        na_position=&#39;last&#39;</span>
<span class="sd">        ignore_index=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">sort_values</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="k">yield</span> <span class="n">result</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">)</span> <span class="k">else</span> <span class="n">result</span></div>



<div class="viewcode-block" id="rename">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.rename">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">rename</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Rename columns or index labels.</span>

<span class="sd">    Function / dict values must be unique (1-to-1). Labels not contained in a</span>
<span class="sd">    dict / Series will be left as-is. Extra labels listed don’t throw an error.</span>

<span class="sd">    See the user guide (https://pandas.pydata.org/docs/user_guide/basics.html#basics-rename)</span>
<span class="sd">    for more.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        mapper=dict</span>
<span class="sd">        index=None</span>
<span class="sd">        columns=None</span>
<span class="sd">        axis=None</span>
<span class="sd">        copy=None</span>
<span class="sd">        inplace=False</span>
<span class="sd">        level=None</span>
<span class="sd">        errors=&#39;ignore&#39;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">rename</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="reset_index">
<a class="viewcode-back" href="../../api/src.html#src.dataframe.reset_index">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">reset_index</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Reset the index, or a level of it.</span>

<span class="sd">    Reset the index of the DataFrame, and use the default one instead. If the</span>
<span class="sd">    DataFrame has a MultiIndex, this method can remove one or more levels.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        level=None</span>
<span class="sd">        drop=False</span>
<span class="sd">        col_level=0</span>
<span class="sd">        col_fill=&#39;&#39;</span>
<span class="sd">        allow_duplicates=_NoDefault.no_default</span>
<span class="sd">        names=None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">reset_index</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">pandas</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../pandas.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>